program gkleinspady_d1
    version 8.2
    args todo b lnf g negH
    tempvar xb Gn gn0 gn1
    mleval `xb' = `b'

    qui summ `xb'
    local width = $stdwidth * r(sd)

    quietly {
      summ $ML_y1, meanonly
      local ybar = r(mean)
      
      kdensity `xb' if $ML_y1==1, nogr gaussian g(`gn1') at(`xb') width(`width')
      kdensity `xb' if $ML_y1==0, nogr gaussian g(`gn0') at(`xb') width(`width')

      gen double `Gn' = `ybar'*`gn1' / ( `ybar'*`gn1' + (1-`ybar')*`gn0' )

      mlsum `lnf' = $ML_y1 * ln(`Gn') + (1-$ML_y1) * ln(1-`Gn')
      if (`todo'==0 | `lnf'>=.)  exit
      
      mlvecsum `lnf' `g' = $ML_y1 * ( `ybar'*`gn1' + (1-`ybar')*`gn0' )/`Gn' - (1-$ML_y1) * ( `ybar'*`gn1' + (1-`ybar')*`gn0' )/(1-`Gn')
     }
end 
